<template>
  <div class="container mx-auto">
    <h3>This is tweet list {{tweet}}{{id}}</h3>
    <ul>
      <Tweet v-for="post in tweets" :key="post.id" :tweet="post">
      </Tweet>
    </ul>
    <form @submit.prevent="onSubmit">
      <input v-model="description" class="border-solid border-gray-500 border-2" placeholder="Enter tweet"/>
      <input type="submit" value="Post tweet" class="ml-2 px-2 border-solid border-2 border-black"/>
    </form>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import Tweet from './Tweet'

export default {
name: 'Tweets',
props: ['tweet'],
data() {
  return {
    id: 0,
    description: '',
  }
},
computed: mapGetters([ 'allTweets', 'tweets', 'user' ]),
components: {
  Tweet
},
methods: {
 onSubmit(e) {
     console.log('IN SUBMIT', this, e)
    const tweet = this.$data.description
    const userId = this.user.id
      this.postTweet({ tweet, userId })
      this.$data.description = ''
   this.$emit('check-submit', this.$data.id) 
 },
 ...mapActions({
    add: 'addTweetAction',
    fetchAllTweets: 'fetchAllTweets',
    postTweet: 'postTweet',
 }),
},
created() {
  if (!this.user) {
    console.log('push to login', this.user)
    this.$router.push('/login')
    return
  }
  this.fetchAllTweets()
}
}
</script>

<style>

</style>
